#include <config.h>

#ifndef __GTOONZ_H_
#define __GTOONZ_H_

#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gconf/gconf-client.h>

#define BUF_SIZE 8192

typedef enum {TTODI, ASEAK, DETUL, MAFIA, HADERI, TOBAK, BLONDY, SKMP,
	      SIMIN, MELANG, WONDERFUL, GAEPAE, CHOONG, MOVIE, ARIRANG, YASA,
	      TAZZA, ZOMBIE, GOOD, HENGGARAE, FIST,
	      MOODAERI, HASU, MYTH, SWEET, SISA,
	      SIKGAEK, NADAERO, C386,
	      SNOWCAT, MARINEBLUES,
	      N_CARTOONS} Cartoon_t;
typedef struct _Item Item;
typedef struct _CartoonInfo CartoonInfo;
typedef struct _Cartoon Cartoon;

struct _Item {
	char *url;
	GtkWidget *da;
	GnomeVFSAsyncHandle *handle;
	GdkPixbufLoader *loader;
	GdkPixbuf *pixbuf;
	char *buf;
	Cartoon *cartoon;   /* parent */
};

struct _CartoonInfo {
	Cartoon_t cartoon_t;
	char *label;
	void (*make_url) (Cartoon *, int, int, int);
};

/* _Cartoon ̸ Gtoonz CartoonApp ٲ  */
struct _Cartoon {
	CartoonInfo *info;
	GSList *item_list;  /* struct _Item list */
	GConfClient *client;
	/* gui */
	GtkWidget *app;
	GtkWidget *images_box;
	GtkWidget *calendar;
};

typedef struct _LocalFile {
	GnomeVFSHandle *fd;
	char *name;
	char *buf;
} LocalFile;

extern CartoonInfo CartoonInfoList[N_CARTOONS];

void gui_init (Cartoon *cartoon);
void download (Cartoon *cartoon);
void status_update (const char *message);

#endif /* __GTOONZ_H_ */
